#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include<stdlib.h>
#define Num  10000
#define N  10

pthread_t mThread[N];

int data[Num];
int partical_sum[N];
int step;
long sum;
 
void *sum_partical(void *t)
{      
     int tid, i;

     tid=(int) t;  

    for(i=tid* step; ( i<(tid+1) *step) &&( i<Num) ; i++)
        partical_sum[tid]= partical_sum[tid]+ data[i];
      

      return NULL;
}


int main(int argc, char *argv[])
{
       int rc, i, sum_parallel;

       for(i=0; i<Num; i++)
             data[i]=i/2;

       for(i=0;i<N;i++)
             partical_sum[i]=0;
 
      step=Num/N;

       for(i=0;i<N; i++)
       {
      
          rc = pthread_create(&mThread[i], NULL, sum_partical, (void *) i);
          if (rc) {
		printf("create thread failed. error code = %d\n", rc);
         	}

        }

    
       for(i=0;i<N; i++)
       {
          pthread_join(mThread[i], NULL);
          sum+=partical_sum[i];
       }


       printf("parallel_sum: the total sum is %ld\n", sum); 

       sum_parallel=sum;
 
       sum =0;

       for(i=0; i<Num; i++)
          sum+=data[i];

       printf("serial sum: the total sum is %ld\n", sum); 

       if(sum_parallel==sum)
           printf("sum==sum_parallel\n");
       else
           printf("sum!=sum_parallel\n");

       printf("main thread finished\n");

	return 0;
}
